import { usePublicHooks } from "@/utils/switchStyle";
import { ElMessageBox } from "element-plus";
import { ref } from "vue";

const { switchStyle } = usePublicHooks();
const switchLoadMap = ref({});
export const tableSwitch = (option) => {
  const loadingChange = (index, status) => {
    switchLoadMap.value[index] = Object.assign(
      {},
      switchLoadMap.value[index],
      {
        loading: status
      }
    );
  }
  const onChange = (scope, index) => {
    loadingChange(index, true)
     option.isTip ? ElMessageBox.confirm(
      `是否确认该操作?`,
      "提示",
      {
        confirmButtonText: "确认",
        cancelButtonText: "取消",
        type: "warning"
      }
     ).then(async () => {
        option.callback(scope,()=>{loadingChange(index, false)})
      }).catch(() => {
      !scope.row[option.fields] ? (scope.row[option.fields] = true) : (scope.row[option.fields] = false);
      loadingChange(index, false)
     }) : option.callback(scope,()=>{loadingChange(index, false)})
  }
 return <div>
    {
      <el-switch
        size={option.scope.props.size === "small" ? "small" : "default"}
        loading={switchLoadMap.value[option.scope.index]?.loading}
        v-model={option.scope.row[option.fields]}
        active-value={option.activeValue}
        inactiveV-value={option.inactiveValue}
        active-text={option.activeText}
        inactive-text={option.inactiveText}
        inline-prompt
        style={switchStyle.value}
        onChange={() => onChange(option.scope as any, option.scope.index)}
      />
    }
  </div>
};
